{"swagger":"2.0","info":{"description":"An overview of A1 ITSM interface powered by ServiceNow.","version":"1.1.0","title":"A1 - ServiceNow Interface","contact":{"email":"muhamed.smajevic@world-direct.at"}},"host":"a1kit.service-now.com","basePath":"/api/x_segh4_cxn/connect/transaction_queue","tags":[{"name":"incident","description":"Incoming messages for incident process."},{"name":"request","description":"Incoming messages for service request process."},{"name":"change","description":"TBD Incoming messages for change request process."},{"name":"problem","description":"TBD Incoming messages for problem process."}],"schemes":["https"],"paths":{"/incident/create":{"post":{"tags":["incident"],"summary":"Create Incident","description":"Creates a new incident at A1.","operationId":"/incident/create","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"Incident information that is being reported.","required":true,"schema":{"$ref":"#/definitions/Incident"}}],"responses":{"200":{"description":"successful operation","schema":{"$ref":"#/definitions/Response"}},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}},"/incident/update":{"post":{"tags":["incident"],"summary":"Update Incident","description":"Updates an incident in A1.","operationId":"/incident/update","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"Incident information that is being updated.","required":true,"schema":{"$ref":"#/definitions/IncidentUpdate"}}],"responses":{"200":{"description":"successful operation","schema":{"$ref":"#/definitions/Response"}},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}},"/incident/attachment":{"post":{"tags":["incident"],"summary":"Add attachment","description":"Adds an attachment to an incident in A1.","operationId":"/incident/attachment","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"Attachment that is being added to the ticket.","required":true,"schema":{"$ref":"#/definitions/Attachment"}}],"responses":{"200":{"description":"successful operation","schema":{"$ref":"#/definitions/Response"}},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}},"/request/create":{"post":{"tags":["request"],"summary":"Create Service Request","description":"Creates a new service request at A1.","operationId":"/request/create","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"Service request information that is being reported.","required":true,"schema":{"$ref":"#/definitions/Request"}}],"responses":{"200":{"description":"successful operation","schema":{"$ref":"#/definitions/Response"}},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}},"/request/update":{"post":{"tags":["request"],"summary":"Update Service Request","description":"Updates a service request in A1.","operationId":"notification","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"Service request information that is being updated.","required":true,"schema":{"$ref":"#/definitions/RequestUpdate"}}],"responses":{"200":{"description":"successful operation","schema":{"$ref":"#/definitions/Response"}},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}},"/request/attachment":{"post":{"tags":["request"],"summary":"Add attachment","description":"Adds an attachment to a service request in A1.","operationId":"attachment","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"Attachment that is being added to the ticket.","required":true,"schema":{"$ref":"#/definitions/Attachment"}}],"responses":{"200":{"description":"successful operation","schema":{"$ref":"#/definitions/Response"}},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}}},"securityDefinitions":{"basicAuth":{"type":"basic"}},"security":[{"basicAuth":[]}],"definitions":{"Incident":{"type":"object","description":"Information about the incident.","required":["sourceId","company","shortDescription","description","serviceOffering"],"properties":{"sourceId":{"type":"string","description":"Foreign Incident Number"},"sourceSysId":{"type":"string","description":"Foreign Incident GUID"},"company":{"type":"string","description":"(Mandatory, if multiple values possible) Reference lookup"},"shortDescription":{"type":"string","description":"Short description of the incident.","format":""},"description":{"type":"string","description":"Detailed description of the incident.","format":""},"creationDate":{"type":"string","description":"Overrides current timestamp, impacts due date. Pattern: yyyy-MM-ddT","format":"date-time"},"dueDate":{"type":"string","description":"SLA calculation in partner system","format":"date-time"},"status":{"type":"string","description":"-","enum":["New","In Progress","On Hold","Resolved","Closed","Canceled"]},"urgency":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"impact":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"assignmentGroup":{"type":"string","description":"-"},"category":{"type":"string","description":"-","enum":["Software","Hardware","Access Management"]},"serviceID":{"type":"string","description":"Reference lookup"},"serviceOffering":{"type":"string","description":"Reference lookup"},"offeringComponent":{"type":"string","description":"Reference lookup"},"ci_id":{"type":"string","description":"Reference lookup"},"ci_company":{"type":"string","description":"Overrides general Company field for this CI / Reference lookup"},"ci_FQDN":{"type":"string","description":"-"},"ci_IP":{"type":"string","description":"-"},"ci_SerialNo":{"type":"string","description":"-"},"ci_InventoryNo":{"type":"string","description":"-"},"affectedUser":{"$ref":"#/definitions/Person"},"caller":{"$ref":"#/definitions/Person"},"contactUser":{"$ref":"#/definitions/Person"},"agent":{"$ref":"#/definitions/Person"},"parentId":{"type":"string","description":"A1 Incident Number of the parent incident, to build a relationship"},"variables":{"type":"array","items":{"$ref":"#/definitions/Variable"}}}},"IncidentUpdate":{"type":"object","description":"Update an incident. Only populated fields are updated.","required":["sourceId"],"properties":{"sourceId":{"type":"string","description":"Foreign Incident Number"},"sourceSysId":{"type":"string","description":"Foreign Incident GUID"},"destinationId":{"type":"string","description":"A1 Incident Number"},"destinationSysId":{"type":"string","description":"A1 Incident GUID"},"workNote":{"type":"string","description":"-"},"workNoteVisibility":{"type":"string","description":"-","enum":["internal","all Interfaces","customer visible"]},"shortDescription":{"type":"string","description":"Short description of the incident.","format":""},"description":{"type":"string","description":"Detailed description of the incident.","format":""},"resolutionText":{"type":"string","description":"Mandatory On status resolved"},"resolutionDate":{"type":"string","description":"If not set on status resolved, current timestamp is used","format":"date-time"},"dueDate":{"type":"string","description":"SLA calculation in partner system","format":"date-time"},"onHoldDueDate":{"type":"string","description":"Used on status On Hold","format":"date-time"},"onHoldReason":{"type":"string","description":"Agreed values, used on status On Hold"},"status":{"type":"string","description":"-","enum":["New","In Progress","On Hold","Resolved","Closed","Canceled"]},"urgency":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"impact":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"assignmentGroup":{"type":"string","description":"-"},"ci_id":{"type":"string","description":"Reference lookup"},"ci_company":{"type":"string","description":"Overrides general Company field for this CI / Reference lookup"},"ci_FQDN":{"type":"string","description":"-"},"ci_IP":{"type":"string","description":"-"},"ci_SerialNo":{"type":"string","description":"-"},"ci_InventoryNo":{"type":"string","description":"-"},"affectedUser":{"$ref":"#/definitions/Person"},"caller":{"$ref":"#/definitions/Person"},"contactUser":{"$ref":"#/definitions/Person"},"agent":{"$ref":"#/definitions/Person"},"parentId":{"type":"string","description":"A1 Incident Number of the parent incident, to build a relationship"},"variables":{"type":"array","description":"List of typed name-value-pairs","items":{"$ref":"#/definitions/Variable"}}}},"Request":{"type":"object","description":"Information about the service request.","required":["sourceId","company","shortDescription","description","serviceOffering"],"properties":{"sourceId":{"type":"string","description":"Foreign Request Number"},"sourceSysId":{"type":"string","description":"Foreign Request GUID"},"company":{"type":"string","description":"Reference lookup"},"shortDescription":{"type":"string","description":"Short description of the request.","format":""},"description":{"type":"string","description":"Detailed description of the request.","format":""},"creationDate":{"type":"string","description":"Overrides current timestamp, impacts due date","format":"date-time"},"dueDate":{"type":"string","description":"SLA calculation in partner system","format":"date-time"},"status":{"type":"string","description":"-","enum":["New","In Progress","On Hold","Closed Complete","Closed Incomplete"]},"urgency":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"impact":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"assignmentGroup":{"type":"string","description":"-"},"activity":{"type":"string","description":"-","enum":["Integration","Warranty Handlin","Roll-Out","New","Change","EVI Urgenz","Remove","Urgenz"]},"category":{"type":"string","description":"Code of a message.","enum":["Software","Hardware","Access Management"]},"serviceID":{"type":"string","description":"Reference lookup"},"serviceOffering":{"type":"string","description":"Reference lookup"},"offeringComponent":{"type":"string","description":"Reference lookup"},"requestedItems":{"type":"array","items":{"$ref":"#/definitions/RequestedItem"}},"ci_id":{"type":"string","description":"Reference lookup"},"ci_company":{"type":"string","description":"Overrides general Company field for this CI / Reference lookup"},"ci_FQDN":{"type":"string","description":"-"},"ci_IP":{"type":"string","description":"-"},"ci_SerialNo":{"type":"string","description":"-"},"ci_InventoryNo":{"type":"string","description":"-"},"requestedFor":{"$ref":"#/definitions/Person"},"requestedBy":{"$ref":"#/definitions/Person"},"contactUser":{"$ref":"#/definitions/Person"},"agent":{"$ref":"#/definitions/Person"},"parentId":{"type":"string","description":"A1 Service Request Number of the parent request, to build a relationship"},"variables":{"type":"array","items":{"$ref":"#/definitions/Variable"}}}},"RequestUpdate":{"type":"object","description":"Information about the service request.","required":["sourceId","company","shortDescription","description","serviceOffering"],"properties":{"sourceId":{"type":"string","description":"Foreign Request Number"},"sourceSysId":{"type":"string","description":"Foreign Request GUID"},"destinationId":{"type":"string","description":"A1 Request Number"},"destinationSysId":{"type":"string","description":"A1 Request GUID"},"workNote":{"type":"string","description":"-"},"workNoteVisibility":{"type":"string","description":"-","enum":["internal","all Interfaces","customer visible"]},"creationDate":{"type":"string","description":"Overrides current timestamp, impacts due date","format":"date-time"},"dueDate":{"type":"string","description":"SLA calculation in partner system","format":"date-time"},"status":{"type":"string","description":"-","enum":["New","In Progress","On Hold","Closed Complete","Closed Incomplete"]},"urgency":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"impact":{"type":"string","description":"1=high, 2=medium, 3=low","enum":["1","2","3"]},"assignmentGroup":{"type":"string","description":"-"},"ci_id":{"type":"string","description":"Reference lookup"},"ci_company":{"type":"string","description":"Overrides general Company field for this CI / Reference lookup"},"ci_FQDN":{"type":"string","description":"-"},"ci_IP":{"type":"string","description":"-"},"ci_SerialNo":{"type":"string","description":"-"},"ci_InventoryNo":{"type":"string","description":"-"},"contactUser":{"$ref":"#/definitions/Person"},"agent":{"$ref":"#/definitions/Person"},"parentId":{"type":"string","description":"A1 Service Request Number of the parent request, to build a relationship"},"variables":{"type":"array","items":{"$ref":"#/definitions/Variable"}}}},"Variable":{"type":"object","description":"Location information.","properties":{"name":{"type":"string","description":"-"},"value":{"type":"string","description":"-"},"type":{"type":"string","description":"Describes the type of the value","enum":["String","Integer","Date","Decimal"]}}},"Person":{"description":"Contact user information.","type":"object","properties":{"company":{"type":"string","description":"Overrides general Company field for this person / Reference lookup"},"userRecordId":{"type":"string","description":"Reference lookup"},"userId":{"type":"string","description":"Reference lookup."},"personnelID":{"type":"string","description":"Reference lookup"},"email":{"type":"string","description":"-"},"firstName":{"type":"string","description":"-"},"lastName":{"type":"string","description":"-"},"businessPhone":{"type":"string","description":"-"},"mobilePhone":{"type":"string","description":"-"},"faxPhone":{"type":"string","description":"-"},"locationId":{"type":"string","description":"Reference lookup"},"street":{"type":"string","description":"-"},"city":{"type":"string","description":"-"},"zip":{"type":"string","description":"-"},"roomNumber":{"type":"string","description":"-"},"costCenterId":{"type":"string","description":"Reference lookup"},"costCenter":{"type":"string","description":"-"},"vip":{"type":"boolean","description":"-"}}},"RequestedItem":{"description":"Contact user information.","type":"object","properties":{"catalogItem":{"type":"string","description":""},"company":{"type":"string","description":"Overrides general Company field for this requested item / Reference lookup"},"serviceOffering":{"type":"string","description":"Overrides general ServiceOffering field for this requested item / Reference lookup"},"amount":{"type":"integer","description":"-"},"shortDescription":{"type":"string","description":"-"},"description":{"type":"string","description":"-"},"requestedFor":{"description":"Overrides RequestedFor for this requested item.","$ref":"#/definitions/Person"},"requestedBy":{"description":"Overrides RequestedBy for this requested item.","$ref":"#/definitions/Person"},"contactUser":{"description":"Overrides ContactUser for this requested item.","$ref":"#/definitions/Person"},"variables":{"type":"array","items":{"$ref":"#/definitions/Variable"}}}},"Attachment":{"type":"object","description":"Attachment.","required":["sourceId","attachmentName","attachmentData"],"properties":{"sourceId":{"type":"string","description":"Foreign Ticket Number"},"sourceSysId":{"type":"string","description":"Foreign Ticket GUID"},"destinationId":{"type":"string","description":"A1 Ticket Number"},"destinationSysId":{"type":"string","description":"A1 Ticket GUID"},"attachmentName":{"type":"string","description":"Full attachment name with extension."},"attachmentType":{"type":"string","description":"Mime type"},"attachmentData":{"type":"string","format":"base64","description":"Code of a message."},"agent":{"$ref":"#/definitions/Person"}}},"Response":{"type":"object","properties":{"transactionId":{"type":"string","description":"Number of transaction"},"targetNumber":{"type":"string","description":"A1 Target Record Number"},"targetSysId":{"type":"string","description":"A1 Target Record GUID"},"targetClass":{"type":"string","description":"Class of the ticket."},"statusCode":{"type":"string","description":"Code for result of processing of the message.","enum":["200","301","302","303","304","305","306","307","308"]},"statusMessage":{"type":"string","description":"Result of the processing of the message.","enum":["Success","Error"]},"errorMessage":{"type":"string","description":"Explanation of the code of processing of the message.","enum":["Processing failed.","STUB not found.","Create Action not possible. Record exists already.","STUB already in state closed, returning ignore.","Update on non-existing record not possible.","Mandatory fields are missing.","Attachment extension is missing.","Update not allowed while ticket is editable at A1."]}}}}}